#define PJON_INCLUDE_SWBB
#include <PJONMaster.h>

uint8_t bus_id[] = {0, 0, 0, 1};
PJONMaster<SoftwareBitBang> bus(bus_id);//PJON_MASTER_ID

void setup() {
  pinMode(13, OUTPUT);
  digitalWrite(13, LOW); // Initialize LED 13 to be off
  Serial.begin(9600);
  bus.strategy.set_pin(7);
  bus.begin();
  bus.set_receiver(receiver_function);
  bus.set_error(error_handler);
  Serial.println("Master initialized");
}
uint32_t time;
uint32_t time2;
int mode = 0;

void loop() {
  if(millis() - time > 2000) {
    if (mode == 0){
      //slave must answer to this
      bus.send(PJON_BROADCAST, "M", 1);
      mode = 1;
    }else {
      //slave will not answer to this
      bus.send(PJON_BROADCAST, "Z", 1);
      mode = 0;
    }
    time = millis();
  }
  if(millis() - time2 > 5000) {
    for(uint8_t i = 0; i < PJON_MAX_DEVICES; i++) {
      if(bus.ids[i].state) {
        Serial.print("Device id: ");
        Serial.print(i + 1); // Shifted by one to avoid PJON_BROADCAST
        Serial.print(" Device rid: ");
        Serial.print(bus.ids[i].rid);
        Serial.print(" | ");
      }
    }
    Serial.println("---");
    time2 = millis();
  }
  bus.update();
  bus.receive(1000);
};

void error_handler(uint8_t code, uint8_t data) {
  if(code == PJON_CONNECTION_LOST) {
    Serial.print("Connection lost with master ");
    Serial.println(bus.packets[data].content[0], DEC);
  }
  if(code == PJON_ID_ACQUISITION_FAIL) {
    Serial.print("Unable to acquire an id: ");
    Serial.println(data);
  }
}

void receiver_function(uint8_t *payload, uint16_t length, const PJON_Packet_Info &packet_info) {
  /* Make use of the payload before sending something, the buffer where payload points to is
     overwritten when a new message is dispatched */
     
  uint32_t rid =
    (uint32_t)(payload[1]) << 24 |
    (uint32_t)(payload[2]) << 16 |
    (uint32_t)(payload[3]) <<  8 |
    (uint32_t)(payload[4]);

  Serial.print("Header: ");
  Serial.print(packet_info.header, BIN);
  Serial.print(" Length: ");
  Serial.print(length);
  Serial.print(" Receiver id: ");
  Serial.print(packet_info.receiver_id);
  Serial.print(" Sender id: ");
  Serial.print(packet_info.sender_id);
  //Serial.print(" Request: ");
  //char cc = payload[0];
  Serial.print(" RID: ");
  Serial.print(rid);
  Serial.print(" Message: ");
  for(uint8_t i = 0; i < length; i++) {
    Serial.print((char)payload[i]);
    //Serial.print(" ");
  }
  //Serial.print(" Packets in buffer: ");
  //Serial.println(bus.update());
  Serial.println();
  
  if (payload[0] == 'U'){
    Serial.println("Slave answer received.");
    digitalWrite(13, HIGH);
    delay(30);
    digitalWrite(13, LOW);
  }

}
