#define PJON_INCLUDE_SWBB

#include <PJONSlave.h>

// <Strategy name> bus(selected device id)
uint8_t bus_id[] = {0, 0, 0, 1};
PJONSlave<SoftwareBitBang> bus(bus_id, PJON_NOT_ASSIGNED);

void setup() {
  Serial.begin(9600);
  pinMode(13, OUTPUT);
  digitalWrite(13, LOW); // Initialize LED 13 to be off

  bus.strategy.set_pin(7);
  bus.begin();
  bus.set_receiver(receiver_function);
  
  Serial.println("Initialized");
};

void receiver_function(uint8_t *payload, uint16_t length, const PJON_Packet_Info &packet_info) {
  /* Make use of the payload before sending something, the buffer where payload points to is
     overwritten when a new message is dispatched */
    //Serial.println(packet_info.sender_bus_id[1]);
  if(payload[0] == 'M') {
    Serial.println("BLINK");
    digitalWrite(13, HIGH);
    delay(30);
    digitalWrite(13, LOW);
    //bus.send(PJON_MASTER_ID, "U", 1);
    char* rr = new char[12];
    char* t = itoa(bus.device_id(), rr, 10);
    Serial.println(t);
    bus.send(PJON_MASTER_ID, t, 3);
  }
}
uint32_t time = 0;

void loop() {
  if(millis() - time > 3000) {
    Serial.print("Device id: ");
    Serial.print(bus.device_id());
    Serial.print(" RID: ");
    Serial.println(bus.get_rid());
    time = millis();
  }
  bus.receive(1000);
  bus.update();
};
